# OBJ Importer Plugin

This unofficial TaleSpire plugin for importing OBJ object that have a single mesh and texture.

This plugin, like all others, is free but if you want to donate, use: http://LordAshes.ca/TalespireDonate/Donate.php

## Change Log

```
1.1.0: Added mesh checks to provide warnings if mesh is missing components or is too big.
1.1.0: Added mesh warnings when mesh is within processing capability but more than the recommended size.
1.0.0: Initial release.
```

## Install

Use R2ModMan or similar installer to install this plugin.

## Usage

1. In the Core TS Library find the Construction Base under Creature | Other | Construction.
2. Add the construction base to the board. It will appear as a bring humanoid.
3. Press the import shortcut key.
4. Type the name of the OBJ file without the extension and press the Build button.

Default: ``RCTRL``+``O``

Note: The first time transforming into a new OBJ file can take a few moments to apply. Successive times changing into
the same OBJ file should take shorter (because the OBJ file conversion is cached in a UOBJ file placed in the same
location as the original file).

## OBJ Limitations

This OBJ importer support only a limited subset of OBJ files. In order for the OBJ Importer to work the following
criteria needs to be met:

1. The OBJ file must have only 1 mesh.

2. The OBJ file must use, at most, only 1 texture.

If the desired OBJ file has multiple meshes or textures use a software like Blender to combine the meshes and texture first.

The OBJ Importer does not use an MTL file but it will automatically loads the texture if there is a PNG, BMP, or JPG file
present in the same folder as the OBJ file and has the same name (except for the extension). For example:

``Dummy.OBJ``
``Dummy.PNG``

A mesh must have V, VN, VT and F components even if a texture is not going to be used with the asset.
The index count for each component cannot exceed 64K. It should be noted that because the OBJ file needs to be converted
to a Unity format, an OBJ mesh which does not exceed the 64K index limit can actually generate a unity converted file
which does exceed this limit. So, it is recommened, as a general rule, to say well below the 64k limit.